<?php

namespace XF2SEO\SEOPackage\XF\Admin\Controller;

use XF\Mvc\FormAction;
use XF\Mvc\Reply\View;
use XF2SEO\SEOPackage\ControllerPlugin\Metadata;

class Forum extends XFCP_Forum
{
    /**
     * @param FormAction $form
     * @param \XF\Entity\Node $node
     * @param \XF\Entity\AbstractNode $data
     * @return void
     */
    protected function saveTypeData(FormAction $form, \XF\Entity\Node $node, \XF\Entity\AbstractNode $data)
    {
        parent::saveTypeData($form, $node, $data);

        /** @var Metadata $metadataPlugin */
        $metadataPlugin = $this->plugin('XF2SEO\SEOPackage:Metadata');
        $metadataPlugin->saveMetadata($data, $this->filter(Metadata::INPUT_PREFIX_METADATA, 'array'));
    }

    /**
     * @param \XF\Entity\Node $node
     * @return mixed
     */
    protected function nodeAddEdit(\XF\Entity\Node $node)
    {
        $reply = parent::nodeAddEdit($node);
        if ($reply instanceof View) {
            $metadata = $this->finder('XF2SEO\SEOPackage:Metadata')
                ->where('content_type', 'forum')
                ->where('content_id', $node->node_id)
                ->fetchOne();
            $reply->setParam('SEOPackage_metadata', $metadata);
        }

        return $reply;
    }
}
